/*
  CPP_CONTEST=2019Enero
  CPP_PROBLEM=D
  CPP_LANG=CPP+OPENMP
  CPP_PROCESSES_PER_NODE=calisto 1
*/

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

void escribirint(int *m, int N,int M) {
//solo para DEBUG
  int i, j;

  for (i = 0; i < N; i++) {
    for (j = 0; j < M; j++)
      printf("%d ", m[i * M + j]);
    printf("\n");
  }
  printf("\n");
}

int  sec(int n,char *C1,char *C2)
{
  int dim=n+1; //fila y columna 0 para casos base
  int resul;
  int *T=(int*) calloc(sizeof(int),dim*dim);
//tabla para programación dinámica
  
  for(int i=0;i<dim;i++)
//caso base fila
     T[i]=0;
  for(int i=1;i<dim;i++)
//caso base columna
     T[i*dim]=0;
  for (int i = 1; i <dim; i++)
  {
     for(int j=1;j<dim;j++)
     {
//máximo de la fila y columna anterior
        int maximo=(T[(i-1)*dim+j]>T[i*dim+j-1]?T[(i-1)*dim+j]:T[i*dim+j-1]);
//si los elementos de las cadenas coinciden y añadiendo 1 al valor en la diagonal 
//anterior es mayor que el máximo, se actualiza
        if(C1[i-1]==C2[j-1] && T[(i-1)*dim+j-1]+1>maximo)
          maximo=T[(i-1)*dim+j-1]+1;
        T[i*dim+j]=maximo;
     }
  }
#ifdef DEBUG
    escribirint(T,dim,dim);
#endif
//la longitud de la cadena más larga es el último valor en la tabla de programación dinámica
  resul=T[dim*dim-1];
  delete[] T;
  return resul;
}

